<template src="./template.html"></template>

<script lang="ts">
import _ from "lodash";
import { Component, Vue, Watch } from "nuxt-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { getTimeZone, getUnixFrom, getUnixTo } from "~/utils/timeZone";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({
  components: {
    Date: () => import("@/components/Seller/Analytics/Revenue/Date/index.vue"),
    Stores: () =>
      import("@/components/Seller/Analytics/Revenue/Stores/index.vue"),
    Products: () =>
      import("@/components/Seller/Analytics/Revenue/Products/index.vue"),
    Hour: () => import("@/components/Seller/Analytics/Revenue/Hour/index.vue"),
    Month: () =>
      import("@/components/Seller/Analytics/Revenue/Month/index.vue"),
  },
})
export default class RevenueComponent extends Vue {
  tab = 0;
  activeButton = 1;
  list: any = [];
  stores: any = [];
  page = 1;
  config = {
    page: this.page,
    limit: 25,
  };
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  loadingTable = false;

  get byTime() {
    return this.$store.state.manageStats.stats;
  }

  set byTime(value: any) {
    this.$store.commit("manageStats/setStats", value);
  }

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get dateRangeText() {
    return this.dateArr.join("~");
  }

  dateRangePicker = false;

  created() {
    this.$store.commit(
      "manageStats/setStatsEachPage",
      "analytic-revenue-seller"
    );
  }

  mounted() {
    // this.onFilterByTime("Today");
    this.onFilterByTime("Today");
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  disabledButtonDate = false;

  async onFilterByTime(time: string) {
    if (time) {
      this.$store.commit("setting/setFilterByTime", { time });
    } else {
      this.$store.commit("setting/setTime", {
        dateStart: this.dateRangeText.split("~")[0],
        dateEnd: this.dateRangeText.split("~")[1],
      });
    }
    // let proms = [];
    this.disabledButtonDate = true;
    await Promise.all([this.onGetStats(), this.onCheckGetList()]);
    this.disabledButtonDate = false;
  }

  async onCheckGetList() {
    this.loadingTable = true;
    if (this.tab == 0) {
      await this.onGetListRevenueDate();
      // proms.push(this.onGetListRevenueDate());
    }
    if (this.tab == 1) {
      await this.onGetListRevenueDomain();
    }
    if (this.tab == 2) {
      await this.onGetListRevenueProduct();
    }
    if (this.tab == 3) {
      await this.onGetListRevenueHour();
    }
    if (this.tab == 4) {
      await this.onGetListRevenueMonth();
    }
    // proms = [...proms, this.onGetListByTime()];

    // await Promise.all(proms);
    this.loadingTable = false;
  }

  async onGetListRevenueDomain() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.revenueDomain({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("home/setListRevenueDomain", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListRevenueMonth() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.revenueMonth({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        const { total } = response;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.$store.commit("home/setListRevenueMonth", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }
  async onGetListRevenueHour() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.revenueHour({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("home/setListRevenueHour", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }
  async onGetListRevenueProduct() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.revenueProduct({
        ...this.config,
        from: this.from || this.dateStart,
        to: this.to || this.dateEnd,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("home/setListRevenueProduct", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListRevenueDate() {
    try {
      let query = {
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      };
      const res = await this.$api.stats.revenueDate(query);
      if (res?.data) {
        this.$store.commit("home/setListRevenueDate", res.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  totalPage: number = 0;
  statsLoading = false;

  stats = {};
  loadingStats = false;

  async onGetStats() {
    try {
      this.loadingStats = true;
      this.stats = {};
      const response = await this.$api.stats.statsByTime({
        ...this.config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.stats = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingStats = false;
    }
  }

  async onSearchByDate() {
    if (this.dateRangeText.split("~").length < 2) {
      return this.$pushNotification.error("Please select 2 days or date range");
    }
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });

    this.timeActive = "";
    this.disabledButtonDate = true;
    await Promise.all([this.onGetStats(), this.onCheckGetList()]);
    this.disabledButtonDate = false;
  }

  @Watch("tab")
  changedTab() {
    this.onFilterByTime(this.timeActive);
  }
}
</script>

<style scoped>
p {
  margin-bottom: 0;
}
</style>
